<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>William's random git tools</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
    <link rel="stylesheet" href="main.css" type="text/css" />
  </head>

  <body>
    <h1>William's random git tools</h1>

    <p> Here are a bunch of random git-related tools I've found useful at some
    point. The git repository for all of these is cloneable
    at <code>git://repo.or.cz/git-walkthrough-commit.git</code> (<a href="http://repo.or.cz/w/git-walkthrough-commit.git">browse</a>).  </p>

    <h2>git-show-merges</h2>

    <p> <a href="git-show-merges">git-show-merges</a> is a simple tool for people with lots of topic
    branches. It shows you which branches have been merged in to the current
    branch, and which haven't. That's it. You can also specify multiple
    non-topic branches (merge branches?) on the commandline.</p>

    <p> <a href="ss2.png"><img src="ss2-small.png" alt="git-show-merges screenshot"/></a>  </p>

    <h2>git-publish-branch</h2>

    <p> <a href="git-publish-branch">git-publish-branch</a> is a simple script
    to ease the unnecessarily complex task of "publishing" a branch, i.e.,
    taking a local branch, creating a reference to it on a remote repo, and
    setting up the local branch to track the remote one, all in one go. </p>

    <p> You give it a branch name, and that branch is published in your remote
    repository. That's it. If you use <code>-d</code>, it will delete the
    remote reference.</p>

    <p>Useful if you publish your topic branches to the outside world.</p>

    <h2>git-rank-contributors</h2>

    <p> <a href="git-rank-contributors">git-rank-contributors</a> is a trivial
    script that paws through your logs and ranks all the contributors by
    the size of their diffs. Remember, as always, bigger is better!</p>

    <p> If you use <code>-v</code>, you'll get the raw diff sizes.</p>

    <p> If you use <code>-o</code>, you'll get high-tech email obfuscation.</p>

    <p> Output with just <code>-o</code> may be suitable for piping into a
    CREDITS file. It probably will require some editing in case people submit
    from more than one email address, though. </p>

    <h2>git-walkthrough-add</h2>

    <p> <i>In recent gits, <code>git add -p</code> does exactly what this tool
    does. So I will not be putting a lot of energy into maintaining this any
    more.</i> </p>

    <p> <a href="git-wt-add">git-wt-add</a> is a darcs-style interactive staging script for git. It
    walks you through unstaged changes on a hunk-by-hunk basis and allows you
    to pick the ones you'd like staged. It features colorized diff output and a
    full set of navigation and dispatch commands.  </p>

    <p> git-wt-add is based on <a
    href="http://thread.gmane.org/gmane.comp.version-control.git/41033">git-hunk-commit</a>
    --darcs, which was very close to what I wanted, but wasn't quite it. In
    general git-wt-add makes no attempt to conform to the real darcs interface,
    but it's probably pretty close. </p>

    <p> <a href="ss1.png"><img src="ss1-small.png" alt="git-wt-add screenshot"/></a> </p>

    <h2>Credit</h2>

    <p>This collection of vaguely useful tools is brought to you by <a href="http://cs.stanford.edu/~ruby/">William Morgan</a> and the following contributors:

    <ul>
      <li> Jeff Balogh &lt;its.jeff.balogh at the gmail dot coms&gt; </li>
    </ul>
    </p>
  </body>
</html>
